/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"time"

	scheme "github.com/IBM/portieris/pkg/apis/securityenforcement/client/clientset/versioned/scheme"
	v1beta1 "github.com/IBM/portieris/pkg/apis/securityenforcement/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterImagePoliciesGetter has a method to return a ClusterImagePolicyInterface.
// A group's client should implement this interface.
type ClusterImagePoliciesGetter interface {
	ClusterImagePolicies() ClusterImagePolicyInterface
}

// ClusterImagePolicyInterface has methods to work with ClusterImagePolicy resources.
type ClusterImagePolicyInterface interface {
	Create(*v1beta1.ClusterImagePolicy) (*v1beta1.ClusterImagePolicy, error)
	Update(*v1beta1.ClusterImagePolicy) (*v1beta1.ClusterImagePolicy, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1beta1.ClusterImagePolicy, error)
	List(opts v1.ListOptions) (*v1beta1.ClusterImagePolicyList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.ClusterImagePolicy, err error)
	ClusterImagePolicyExpansion
}

// clusterImagePolicies implements ClusterImagePolicyInterface
type clusterImagePolicies struct {
	client rest.Interface
}

// newClusterImagePolicies returns a ClusterImagePolicies
func newClusterImagePolicies(c *SecurityenforcementV1beta1Client) *clusterImagePolicies {
	return &clusterImagePolicies{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterImagePolicy, and returns the corresponding clusterImagePolicy object, and an error if there is any.
func (c *clusterImagePolicies) Get(name string, options v1.GetOptions) (result *v1beta1.ClusterImagePolicy, err error) {
	result = &v1beta1.ClusterImagePolicy{}
	err = c.client.Get().
		Resource("clusterimagepolicies").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterImagePolicies that match those selectors.
func (c *clusterImagePolicies) List(opts v1.ListOptions) (result *v1beta1.ClusterImagePolicyList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.ClusterImagePolicyList{}
	err = c.client.Get().
		Resource("clusterimagepolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterImagePolicies.
func (c *clusterImagePolicies) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("clusterimagepolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a clusterImagePolicy and creates it.  Returns the server's representation of the clusterImagePolicy, and an error, if there is any.
func (c *clusterImagePolicies) Create(clusterImagePolicy *v1beta1.ClusterImagePolicy) (result *v1beta1.ClusterImagePolicy, err error) {
	result = &v1beta1.ClusterImagePolicy{}
	err = c.client.Post().
		Resource("clusterimagepolicies").
		Body(clusterImagePolicy).
		Do().
		Into(result)
	return
}

// Update takes the representation of a clusterImagePolicy and updates it. Returns the server's representation of the clusterImagePolicy, and an error, if there is any.
func (c *clusterImagePolicies) Update(clusterImagePolicy *v1beta1.ClusterImagePolicy) (result *v1beta1.ClusterImagePolicy, err error) {
	result = &v1beta1.ClusterImagePolicy{}
	err = c.client.Put().
		Resource("clusterimagepolicies").
		Name(clusterImagePolicy.Name).
		Body(clusterImagePolicy).
		Do().
		Into(result)
	return
}

// Delete takes name of the clusterImagePolicy and deletes it. Returns an error if one occurs.
func (c *clusterImagePolicies) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clusterimagepolicies").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterImagePolicies) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("clusterimagepolicies").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched clusterImagePolicy.
func (c *clusterImagePolicies) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.ClusterImagePolicy, err error) {
	result = &v1beta1.ClusterImagePolicy{}
	err = c.client.Patch(pt).
		Resource("clusterimagepolicies").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
