/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1beta1

import (
	time "time"

	versioned "github.com/IBM/portieris/pkg/apis/securityenforcement/client/clientset/versioned"
	internalinterfaces "github.com/IBM/portieris/pkg/apis/securityenforcement/client/informers/externalversions/internalinterfaces"
	v1beta1 "github.com/IBM/portieris/pkg/apis/securityenforcement/client/listers/securityenforcement/v1beta1"
	securityenforcementv1beta1 "github.com/IBM/portieris/pkg/apis/securityenforcement/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ImagePolicyInformer provides access to a shared informer and lister for
// ImagePolicies.
type ImagePolicyInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1beta1.ImagePolicyLister
}

type imagePolicyInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewImagePolicyInformer constructs a new informer for ImagePolicy type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewImagePolicyInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredImagePolicyInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredImagePolicyInformer constructs a new informer for ImagePolicy type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredImagePolicyInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SecurityenforcementV1beta1().ImagePolicies(namespace).List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SecurityenforcementV1beta1().ImagePolicies(namespace).Watch(options)
			},
		},
		&securityenforcementv1beta1.ImagePolicy{},
		resyncPeriod,
		indexers,
	)
}

func (f *imagePolicyInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredImagePolicyInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *imagePolicyInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&securityenforcementv1beta1.ImagePolicy{}, f.defaultInformer)
}

func (f *imagePolicyInformer) Lister() v1beta1.ImagePolicyLister {
	return v1beta1.NewImagePolicyLister(f.Informer().GetIndexer())
}
